/* $Id: app.c,v 1.1 1997/11/05 21:38:11 wtcorrea Exp wtcorrea $ */

#include <stdio.h>
#include <stdlib.h>
#include "app.h"
#include "device.h"
#include "gldriver.h"
#include "ivparse.h"
#include "my.h"

#define NDEBUG
#include "debug.h"

app_t app;

void app_b1_click(int x, int y, int s)
{
    DEBUG(fprintf(stderr, "app_b1_click %d %d %d\n", x, y, s));
}

void app_b1_dclick(int x, int y, int s)
{
    (void) (s);
    app.x1 = x, app.y1 = y;
}

void app_b1_motion(int x, int y, int s)
{
    (void) (x, y, s);
}

void app_b1_release(int x, int y, int s)
{
    DEBUG(fprintf(stderr, "app_b1_release %d %d %d\n", x, y, s));
}

void app_config(int w, int h)
{
    DEBUG(fprintf(stderr, "app_config %d %d\n", w, h));
    app.w = w, app.h = h;
    dev_set_viewport(0, 0, app.w, app.h);
}

void app_motion(int x, int y, int s)
{
    (void) (x, y, s);
}

void app_redraw(void)
{
    DEBUG(fprintf(stderr, "app_redraw\n"));
    dev_set_clear_color((double) app.r / 255.0, (double) app.g / 255.0,
        (double) app.b / 255.0);
    dev_clear();
    if (app.model != NULL) {
        iv_traverse(1, 1, 1, 1);
    }
    app.redraw = 0;
}

void app_set_model(char *filename)
{
    app.model = filename;
    iv_parse(filename);
}
