# $Id: color.tcl,v 1.1 1997/11/05 21:38:11 wtcorrea Exp wtcorrea $

proc select_color {} {
   global red
   global green
   global blue

   #
   # Save old color
   #

   set oldred $red
   set oldgreen $green
   set oldblue $blue

   #
   # Create the dialog window
   #
   toplevel .chcolor -borderwidth 10
   wm title .chcolor {Select Color}

   #
   # OK and Cancel buttons
   #

   frame .chcolor.bottom

   button .chcolor.ok \
      -text OK \
      -command {
         destroy .chcolor
      }

   #
   # See [Ousterhout, 1994] p. 270 for an explanation for the use of quotes
   # instead of braces in the following -command.
   #

   button .chcolor.cancel \
      -text Cancel \
      -command "
         set red $oldred
         set green $oldgreen
         set blue $oldblue
         destroy .chcolor
      "

   pack .chcolor.ok -in .chcolor.bottom -side left -expand yes
   pack .chcolor.cancel -in .chcolor.bottom -side left -expand yes
   pack .chcolor.bottom -side bottom -fill x

   #
   # RGB scales
   #

   frame .chcolor.scales

   scale .chcolor.red \
      -label "Red" \
      -from 0 \
      -to 255 \
      -length 10c \
      -orient horizontal \
      -command show_newcolor \
      -tickinterval 255 \
      -showvalue true

   scale .chcolor.green \
      -label "Green" \
      -from 0 \
      -to 255 \
      -length 10c \
      -orient horizontal \
      -command show_newcolor \
      -tickinterval 255 \
      -showvalue true

   scale .chcolor.blue \
      -label "Blue" \
      -from 0 \
      -to 255 \
      -length 10c \
      -orient horizontal \
      -command show_newcolor \
      -tickinterval 255 \
      -showvalue true

   pack .chcolor.red -in .chcolor.scales
   pack .chcolor.green -in .chcolor.scales
   pack .chcolor.blue -in .chcolor.scales
   pack .chcolor.scales -side left

   #
   # Color samples
   #

   label .chcolor.current \
      -text "Current"

   frame .chcolor.curcolor \
      -width 2c \
      -height 2c \
      -bg [format "#%02x%02x%02x" $red $green $blue]

   label .chcolor.new \
      -text "New"

   frame .chcolor.newcolor \
      -width 2c \
      -height 2c \
      -bg [format "#%02x%02x%02x" $red $green $blue]

   pack .chcolor.current
   pack .chcolor.curcolor
   pack .chcolor.new
   pack .chcolor.newcolor

   grab set .chcolor
   tkwait window .chcolor
}

proc show_newcolor {value} {
   global red
   global green
   global blue

   set red [.chcolor.red get]
   set green [.chcolor.green get]
   set blue [.chcolor.blue get]
   set color [format #%02x%02x%02x $red $green $blue]
   .chcolor.newcolor configure -background $color
}
